package com.langtech.plm.performancemanagement.handlers;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDate;
import java.time.ZoneId;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentTcFile;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.FileUtility;
import com.teamcenter.rac.util.MessageBox;

/**
 * ѡĿļУЧ ݿάҪ
 * 
 * 
 */
public class TaskFolderMatchingHandler extends AbstractHandler {
	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		AbstractAIFApplication app = AIFUtility.getCurrentApplication();
		TCSession session = (TCSession) app.getSession();
		TCComponent target = null;
		target = (TCComponent) app.getTargetComponent();
		// ѡĿͣ򱨴
		String type = target.getType();
		if (type.equals("LD6_CusProdFolder") || type.equals("ͻƷļ")) {
			// TODO ݿⷽʽά
//			TCComponent[] workRequest = null;
//			try {
//				workRequest = session.search("...", new String[] { "", "" }, new String[] { "Ҫ", "xxxx" });
//			} catch (Exception e) {
//				e.printStackTrace();
//				MessageBox.post("ѯ쳣", "", MessageBox.INFORMATION);
//			}
//			if (workRequest.length == 0) {
//				MessageBox.post("ϵͳûҪ뵼", "", MessageBox.INFORMATION);
//			} else if (workRequest.length > 1) {
//
//				MessageBox.post("ϵͳдڶҪ", "", MessageBox.INFORMATION);
//			}
			// 鱨ģǷڣѡld_billboards_uid
			String ldBillboardsUid = session.getPreferenceService().getStringValue("ld_billboards_uid");
			if (!getMessageboxInfo(ldBillboardsUid, "ld_billboards_uid")) {
				return null;
			}
			TCComponent billboard = null;
			try {
				billboard = session.stringToComponent(ldBillboardsUid);
			} catch (TCException e) {
				e.printStackTrace();
				MessageBox.post("֪ͨԱѡld_billboards_uidǷ", "", MessageBox.INFORMATION);
				return null;
			}
			if (billboard == null) {
				MessageBox.post("֪ͨԱѡld_billboards_uidǷ", "", MessageBox.INFORMATION);
				return null;
			}
			// ȡλϵ Ѷϵ Ŷϵ Ҫʱ乫ʽѡ
			String[] ldPostCoefficient = session.getPreferenceService().getStringValues("ld_postCoefficient");
			String[] ldTaskNature = session.getPreferenceService().getStringValues("ld_taskNature");// ѶϵӦѶϵ
			String[] ldUrgency = session.getPreferenceService().getStringValues("ld_urgency");
			// ʱ
			String[] ldOvertime = session.getPreferenceService().getStringValues("ld_overtime");// صȼ:䣨[0,0]:۷ϵ;һ:(0,1]:1/5;:(1,2]:1/3;:(2,3]:1/2
			// Ϣó =:˽ڵ
			String[] ldProcessReview = session.getPreferenceService().getStringValues("ld_processReview");
			if (!getMessageInfo(ldPostCoefficient, "ld_processReview")) {
				return false;
			}
			if (!getMessageInfo(ldTaskNature, "ld_taskNature")) {
				return false;
			}
			if (!getMessageInfo(ldUrgency, "ld_urgency")) {
				return false;
			}
			if (!getMessageInfo(ldProcessReview, "ld_processReview")) {
				return false;
			}
			if (!getMessageInfo(ldOvertime, "ld_overtime")) {
				return false;
			}
			Map<String, String> postCoefficientMap = new HashMap<String, String>();// λλϵ
			Map<String, String> taskNatureMap = new HashMap<String, String>();// ʣϵ
			Map<String, String> urgencyMap = new HashMap<String, String>();// ̶ȣ̶ϵ
			Map<String, String> processReviewMap = new HashMap<String, String>();// ƣָɵĽڵ
			Map<String, String> severityIntervalMap = new HashMap<String, String>();// 䣻ֵ۷ϵ
			for (int i = 0; i < ldPostCoefficient.length; i++) {
				String value = ldPostCoefficient[i];
				postCoefficientMap.put(value.split("=")[0], value.split("=")[0]);
			}
			for (int i = 0; i < ldTaskNature.length; i++) {
				String value = ldTaskNature[i];
				taskNatureMap.put(value.split("=")[0], value.split("=")[0]);
			}
			for (int i = 0; i < ldUrgency.length; i++) {
				String value = ldUrgency[i];
				urgencyMap.put(value.split("=")[0], value.split("=")[0]);
			}
			for (int i = 0; i < ldProcessReview.length; i++) {
				String value = ldProcessReview[i];
				processReviewMap.put(value.split("=")[0], value.split("=")[0]);
			}
			for (int i = 0; i < ldOvertime.length; i++) {
				String dayInterval = ldOvertime[i].split(":")[1];
				String severity = ldOvertime[i].split(":")[0];
				String point = ldOvertime[i].split(":")[2];
				severityIntervalMap.put(dayInterval, point);
			}
			// رúҪ
			String billboardAddress = downLoadFile(billboard);
			// TODO ȡսʱ
			String targetName = "";
			try {
				targetName = target.getProperty("object_name");
			} catch (TCException e) {
				e.printStackTrace();
			}
			Date processEndTime = getEndTime(targetName);
			if (processEndTime == null) {
				MessageBox.post("ǷûߵؿͻƷļƺ͹ճʱ", "", MessageBox.INFORMATION);
				return null;
			}
			// ȡ ֯
			// ȱײṹ
			String path = "";
			path = targetName;
			String link = "/";
			List<String> taskPathList = new ArrayList<String>();
			Map<String, TCComponent> folderMap = new HashMap<String, TCComponent>();// ļв㼶ṹ ֵļж
			getAllFolderPath(target, path, link, taskPathList, folderMap);
			// ȡѡConnor_JXFolder
			Map<String, List<String>> packageMap = new HashMap<String, List<String>>();
			String connorJXFolderPreference = "Connor_JXFolder";
			String[] ConnorJXFolders = session.getPreferenceService().getStringValues(connorJXFolderPreference);
			if (getMessageInfo(ConnorJXFolders, connorJXFolderPreference)) {
				return false;
			}
			for (int i = 0; i < ConnorJXFolders.length; i++) {
				String[] values = ConnorJXFolders[i].split("=");
				String[] folders = values[1].split(";");
				List<String> folderList = Arrays.asList(folders);
				packageMap.put(values[0], folderList);
			}
			// ȡϢ
			File file = new File(billboardAddress);
			XSSFWorkbook workbook = null;
			try {
				FileInputStream fis = new FileInputStream(file);
				workbook = new XSSFWorkbook(fis);
			} catch (IOException e) {
				e.printStackTrace();
			}
			XSSFSheet sheet = workbook.getSheet("Ʒ");
			int rowNum = sheet.getLastRowNum();
			for (int i = 1; i < rowNum; i++) {
				XSSFRow row = sheet.getRow(i);
				String cellBValue = row.getCell(1).getStringCellValue().trim();// 
				List<String> folderList = packageMap.get(cellBValue);
				if (folderList != null && folderList.size() > 0) {
					String folderPath = folderList.get(0);
					TCComponent folder = folderMap.get(folderPath);
					String[] properties = new String[] { "object_desc", "", "׳̶", "̶", "ҵʱ(Сʱ)",
							"fnd0AllWorkflows" };
					TCProperty[] tcproperties = null;
					try {
						tcproperties = folder.getTCProperties(properties);
					} catch (TCException e) {
						e.printStackTrace();
					}
					// ƷҪ
					String objectDesc = tcproperties[0].getStringValue();
					String taskNature = tcproperties[1].getDisplayValue();
					String difficulty = tcproperties[2].getDisplayValue();
					String urgency = tcproperties[3].getDisplayValue();
					String ratedBusinessHours = tcproperties[4].getStringValue();
					String taskNatureCoefficient = taskNatureMap.get(difficulty);
					String urgencyCoefficient = urgencyMap.get(urgency);
					String postCoefficient = "";// 
					// ȡϢ
					String processReview = processReviewMap.get(cellBValue);
					String processName = processReview.split(":")[0];
					String reviewName = processReview.split(":")[1];
					String assignee = "";// ָfnd0Assigneeûоתָ߼̽ߣͬη
					String assigner = "";// ָfnd0Assignerûоתûֵȡָ
					String assigneeGroup = "";// ָߵ
					String status = "";// ״̬
					String startData = "";// ̿ʼʱ
					String endDateValue = "";// ̽ʱ
					String actualHours = "";// ʵҵʱ
					String deductPoints = "";// ʱ۷
					TCComponent[] workflows = tcproperties[5].getReferenceValueArray();
					for (int j = 0; j < workflows.length; j++) {
						TCComponent workflow = workflows[j];
						try {
							String[] workflowProperties = new String[] { "object_name", "fnd0ActuatedInteractiveTsks",
									"fnd0EndDate", "fnd0StartDate", "fnd0Status" };
							TCProperty[] workflowTcProperties = workflow.getTCProperties(workflowProperties);
							String workflowName = workflowTcProperties[0].getDisplayValue();
							TCComponent[] reviews = workflowTcProperties[1].getReferenceValueArray();
							if (workflowName.equals(processName)) {
								for (int k = 0; k < reviews.length; k++) {
									TCComponent review = reviews[k];
									String typeName = review.getType();
									if (typeName.equals("ǩ")) {// fnd0AliasTaskName;ִߣfnd0Performer
																// fnd0AssigneeGroupRole owning_group
										String[] reviewProperties = new String[] { "fnd0AliasTaskName", "fnd0Performer",
												"owning_group", "fnd0Assigner", "fnd0Assignee" };
										TCProperty[] reviewTcProperties = review.getTCProperties(reviewProperties);
										String aliasTaskName = reviewTcProperties[0].getDisplayValue();
										if (aliasTaskName.contains(":")) {
											String reviewNodeName = aliasTaskName.split(":")[0];
											if (reviewNodeName.equals(reviewName)) {
												assignee = reviewTcProperties[4].getDisplayValue();
												assigneeGroup = reviewTcProperties[2].getDisplayableValue();
												TCProperty assigneeProperty = reviewTcProperties[3];
												if (assigneeProperty.getDisplayValue().length() > 0) {
													assigner = assigneeProperty.getDisplayValue();
												} else {
													assigner = assignee;
												}
											}
										}
										status = workflowTcProperties[4].getDisplayValue().equals("") ? ""
												: "δ";
										endDateValue = workflowTcProperties[2].getDisplayValue();
										Date startDate = workflowTcProperties[2].getDateValue();
										Date endDate = workflowTcProperties[3].getDateValue();
										actualHours = "" + (endDate.getTime() - startDate.getTime()) / 1000 / 3600;
										float point = (float) 0.0;
										if (status.equals("")) {
											ZoneId zoneId = ZoneId.systemDefault();
											Instant instantEnd = endDate.toInstant();
											Instant instantProcessEnd = processEndTime.toInstant();
											LocalDate localEndDate = instantEnd.atZone(zoneId).toLocalDate();
											LocalDate localProcessEndDate = instantProcessEnd.atZone(zoneId)
													.toLocalDate();
											long diff = localEndDate.toEpochDay() - localProcessEndDate.toEpochDay();
											String overtimeCoefficient = "";// ۷ϵ
											postCoefficient = postCoefficientMap.get(assigneeGroup);
											for (Map.Entry<String, String> me : severityIntervalMap.entrySet()) {
												String interval = me.getKey();
												String startDay = interval.split(",")[0];
												String endDay = interval.split(",")[1];
												boolean condition1 = false;
												boolean condition2 = false;
												if (startDay.startsWith("[")) {
													condition1 = diff >= (Integer
															.valueOf(startDay.substring(1, startDay.length() - 1)))
																	? true
																	: false;
												} else if (startDay.startsWith("(")) {
													condition1 = diff > (Integer
															.valueOf(startDay.substring(1, startDay.length() - 1)))
																	? true
																	: false;
												}
												if (endDay.endsWith("]")) {
													condition2 = diff <= (Integer
															.valueOf(endDay.substring(0, endDay.length() - 2))) ? true
																	: false;
												} else if (startDay.startsWith(")")) {
													condition2 = diff < (Integer
															.valueOf(endDay.substring(0, endDay.length() - 2))) ? true
																	: false;
												}
												if (condition1 == true && condition2 == true) {
													overtimeCoefficient = me.getValue();
												} else {
													continue;
												}
											}
											if (!overtimeCoefficient.equals("")) {
												point = 1 * Float.valueOf(overtimeCoefficient)
														* Float.valueOf(taskNatureCoefficient)
														* Float.valueOf(urgencyCoefficient);// TODO ʽʱʺѶϵ
											}
										}
									}
								}
							}
						} catch (TCException e) {
							e.printStackTrace();
						}
					}
				} else {
					continue;
				}
			}
		} else {
			MessageBox.post("ѡͻƷļ", "", MessageBox.INFORMATION);
		}
		return null;
	}

	/**
	 * ͨݷʽȡսʱ
	 */
	private Date getEndTime(String targetName) {
		// TODO
		return null;
	}

	/**
	 * ѡǷ
	 * 
	 * @param preferenceValue ѡֵ
	 * @param preferenceName  ѡ
	 * @return ûþͷfalse
	 */
	private boolean getMessageInfo(String[] preferenceValue, String preferenceName) {
		if (preferenceValue == null || preferenceValue.length == 0) {
			MessageBox.post("֪ͨԱѡ" + preferenceName + "Ƿ", "", MessageBox.INFORMATION);
			return false;
		}
		return true;
	}

	/**
	 * ѡǷ
	 * 
	 * @param preferenceValue ѡֵ
	 * @param preferenceName  ѡ
	 * @return ûþͷfalse
	 */
	private boolean getMessageboxInfo(String preferenceValue, String preferenceName) {
		if (preferenceValue == null || preferenceValue.length() == 0) {
			MessageBox.post("֪ͨԱѡ" + preferenceName + "Ƿ", "", MessageBox.INFORMATION);
			return false;
		}
		return true;
	}

	/**
	 * ѭĿļµļУӵϺmap
	 * 
	 * @param target       ļ
	 * @param path         ļ·
	 * @param link         ӷ
	 * @param taskPathList ·
	 * @param folderMap    ·
	 * @return صļ
	 */
	private void getAllFolderPath(TCComponent target, String path, String link, List<String> taskPathList,
			Map<String, TCComponent> folderMap) {
		try {
			TCComponent[] contents = target.getRelatedComponents("contents");
			for (int i = 0; i < contents.length; i++) {
				TCComponent content = contents[i];
				TCComponent[] childContents = content.getRelatedComponents("contents");
				path = path + link + content.getProperty("object_name");
				if (childContents.length > 0) {
					getAllFolderPath(content, path, link, taskPathList, folderMap);
				} else {
					taskPathList.add(path);
					folderMap.put(path, content);
				}
			}
		} catch (TCException e) {
			e.printStackTrace();
		}
	}

	/**
	 * ļ
	 * 
	 * @param ݼ
	 * @return صļ
	 */
	public String downLoadFile(TCComponent comp) {
		if (comp == null) {
			return "";
		}
		String value = "";
		String tempPath = System.getenv("TEMP");
		if (tempPath == null) {
			tempPath = "";
		} else if (!tempPath.endsWith("\\")) {
			tempPath = tempPath + "\\";
		}
		SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmssSSS");
		try {
			if (comp instanceof TCComponentDataset) {
				TCComponentTcFile[] tcFiles = ((TCComponentDataset) comp).getTcFiles();
				File file = null;
				System.out.println("tcFiles:" + tcFiles.length);
				if (tcFiles != null && tcFiles.length != 0) {
					file = tcFiles[0].getFmsFile();
					String fileName = file.getName();
					System.out.println("fileName:" + fileName);
					String fileDix = fileName.substring(fileName.lastIndexOf("."), fileName.length());
					fileName = tempPath + sdf.format(new Date()) + fileDix;
					File dirFile = new File(fileName);
					FileUtility.copyFile(file, dirFile);
					return fileName;
				}
			}
		} catch (TCException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return value;
	}
}
